package com.asreader.asfinger;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.Toast;

import com.asreader.asfingersdk.AsFingerSDK;
import com.asreader.asfingersdk.event.AsFingerEventListener;
import com.asreader.asfingersdk.type.AsFingerConnectionType;

public class Setting extends Activity implements View.OnClickListener {


    private static final String TAG = Setting.class.getSimpleName();
    private Button mBtBasicInformation;
    private Button mBtSearch;
    private ImageButton mIbBack;
    private AsFingerSDK mAsFingerSDK;
    private BluetoothAdapter mBtAdapter;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_setting);
        mBtAdapter = BluetoothAdapter.getDefaultAdapter();

        initView();

        mAsFingerSDK = AsFingerSDK.getInstance();

    }

    @Override
    protected void onStart() {
        super.onStart();
        Log.i(TAG,"onStart");
        mAsFingerSDK.setActivity(this);
        if (mBtAdapter == null) {
            return;
        }
//        if (!mBtAdapter.isEnabled()){
//            mBtAdapter.enable();
//
//        }


    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.i(TAG,"onResume");
        mAsFingerSDK.setAsFingerEventListener(mAsFingerEventListener);
    }

    @Override
    protected void onPause() {
        super.onPause();

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mAsFingerEventListener = null;
    }

    private void initView() {
        mBtSearch = (Button) findViewById(R.id.bt_search);
        mBtBasicInformation = (Button) findViewById(R.id.bt_basic_information);
        mIbBack = (ImageButton) findViewById(R.id.ib_back);
        mBtBasicInformation.setOnClickListener(this);
        mBtSearch.setOnClickListener(this);
        mIbBack.setOnClickListener(this);

    }


    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.bt_search:
                Intent searchIntent = new Intent(Setting.this, SearchAcitvity.class);
                startActivity(searchIntent);
                break;
            case R.id.bt_basic_information:
                Intent informationIntent = new Intent(Setting.this, InformationActivity.class);
                startActivity(informationIntent);
                break;
            case R.id.ib_back:
                finish();
                break;
        }


    }

    private AsFingerEventListener mAsFingerEventListener = new AsFingerEventListener() {

        @Override
        public void onStateChanged(AsFingerConnectionType connectionType) {
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    switch (connectionType) {
                        case connected:
                            Toast.makeText(Setting.this,
                                    getResources().getString(R.string.toast_connect_device) + " " + mAsFingerSDK.connectedDevice().getName(), Toast.LENGTH_LONG).show();
                            break;
                        case disconnected:
                            Toast.makeText(Setting.this,
                                    getResources().getString(R.string.toast_disconnect_device), Toast.LENGTH_LONG).show();
                            break;
                        case connecting:
                            Toast.makeText(Setting.this,
                                    getResources().getString(R.string.toast_connecting_device), Toast.LENGTH_LONG).show();
                            break;
                    }
                }
            });

        }

        @Override
        public void receivedBarcodeData(byte[] barcodeData) {
        }

        @Override
        public void receivedBattery(int battery) {

        }

        @Override
        public void receivedFirmwareVersion(String firmwareVersion) {

        }

        @Override
        public void receivedData(byte[] data) {

        }

        @Override
        public void receivedDevice(BluetoothDevice device) {

        }

        @Override
        public void receivedFoundDeviceFinished() {

        }


    };


}
